# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cam_ts_msgs/RoadWorksContainerBasic.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cam_ts_msgs.msg

class RoadWorksContainerBasic(genpy.Message):
  _md5sum = "eda0a61fd74a2bdc7623de8e8d6f68a1"
  _type = "etsi_its_cam_ts_msgs/RoadWorksContainerBasic"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
#  /**
# * This type contains detaild information of the Road Works Container Basic.
# *
# * It shall include the following components:
# *
# * @field roadworksSubCauseCode: The optional component, in case the originating ITS-S is mounted to a vehicle ITS-S participating to roadwork. It 
# * provides information on the type of roadwork that it is currently undertaking. This component shall be present if the data is available in 
# * originating ITS S.
# *
# * @field lightBarSirenInUse: it indicates whether light-bar or a siren is in use by the vehicle originating the CAM.
# *
# * @field closedLanes: an optional component which provides information about the opening/closure status of the lanes ahead. Lanes are counted from
# * the outside boarder of the road. If a lane is closed to traffic, the corresponding bit shall be set to 1.
# */
#  RoadWorksContainerBasic ::= SEQUENCE {
#   roadworksSubCauseCode RoadworksSubCauseCode OPTIONAL,
#   lightBarSirenInUse LightBarSirenInUse,
#   closedLanes ClosedLanes OPTIONAL
#  }
# ------------------------------------------------------------------------------

RoadworksSubCauseCode roadworks_sub_cause_code
bool roadworks_sub_cause_code_is_present

LightBarSirenInUse light_bar_siren_in_use

ClosedLanes closed_lanes
bool closed_lanes_is_present


================================================================================
MSG: etsi_its_cam_ts_msgs/RoadworksSubCauseCode
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE represents the value of the sub cause codes of the @ref CauseCode `roadworks`.
#  * 
# The value shall be set to:
#  * - 0 `unavailable`                 - in case further detailed information on roadworks is unavailable,
#  * - 1 `majorRoadworks`              - in case a major roadworks is ongoing,
#  * - 2 `roadMarkingWork`             - in case a road marking work is ongoing,
#  * - 3 `slowMovingRoadMaintenance`   - in case slow moving road maintenance work is ongoing,
#  * - 4 `shortTermStationaryRoadworks`- in case a short term stationary roadwork is ongoing,
#  * - 5 `streetCleaning`              - in case a vehicle street cleaning work is ongoing,
#  * - 6 `winterService`               - in case winter service work is ongoing.
#  * - 7-255                           - are reserved for future usage.
#  *
#  * @category: Traffic information
#  * @revision: V1.3.1
#  */
# RoadworksSubCauseCode ::= INTEGER {
#     unavailable                  (0), 
#     majorRoadworks               (1),
#     roadMarkingWork              (2), 
#     slowMovingRoadMaintenance    (3), 
#     shortTermStationaryRoadworks (4), 
#    streetCleaning                (5), 
#    winterService                 (6)
# } (0..255)
# ------------------------------------------------------------------------------

uint8 value
uint8 MIN = 0
uint8 MAX = 255
uint8 UNAVAILABLE = 0
uint8 MAJOR_ROADWORKS = 1
uint8 ROAD_MARKING_WORK = 2
uint8 SLOW_MOVING_ROAD_MAINTENANCE = 3
uint8 SHORT_TERM_STATIONARY_ROADWORKS = 4
uint8 STREET_CLEANING = 5
uint8 WINTER_SERVICE = 6


================================================================================
MSG: etsi_its_cam_ts_msgs/LightBarSirenInUse
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the status of light bar and any sort of audible alarm system besides the horn.
#  * This includes various common sirens as well as backup up beepers and other slow speed manoeuvring alerts.
#  *
#  * The corresponding bit shall be set to 1 under the following conditions:
#  * - 0 - `lightBarActivated`      - when the light bar is activated,
#  * - 1 - `sirenActivated`         - when the siren is activated.
#  *
#  * Otherwise, it shall be set to 0.
#  *
#  * @category Vehicle information
#  * @revision: Editorial update in V2.1.1
#  */
# LightBarSirenInUse ::= BIT STRING {
#     lightBarActivated (0),
#     sirenActivated    (1)
# } (SIZE(2))
# ------------------------------------------------------------------------------

uint8[] value
uint8 bits_unused
uint8 SIZE_BITS = 2
uint8 BIT_INDEX_LIGHT_BAR_ACTIVATED = 0
uint8 BIT_INDEX_SIREN_ACTIVATED = 1


================================================================================
MSG: etsi_its_cam_ts_msgs/ClosedLanes
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DF indicates the opening/closure status of the lanes of a carriageway.
#  *
#  * It shall include the following components: 
#  * 
#  * @field innerhardShoulderStatus: this information is optional and shall be included if an inner hard shoulder is present and the information is known.
#  * It indicates the open/closing status of inner hard shoulder lanes. 
#  * 
#  * @field outerhardShoulderStatus: this information is optional and shall be included if an outer hard shoulder is present and the information is known.
#  * It indicates the open/closing status of outer hard shoulder lanes. 
#  * 
#  * @field drivingLaneStatus: this information is optional and shall be included if the information is known.
#  * It indicates the open/closing status of driving lanes. 
#  * For carriageways with more than 13 driving lanes, the drivingLaneStatus component shall not be present.
#  * 
#  * @category: Infrastructure information, Road topology information
#  * @revision: Description revised in V2.1.1
#  */
# ClosedLanes ::= SEQUENCE {
#     innerhardShoulderStatus    HardShoulderStatus OPTIONAL,
#     outerhardShoulderStatus    HardShoulderStatus OPTIONAL,
#     drivingLaneStatus          DrivingLaneStatus OPTIONAL,
#     ...
# }
# ------------------------------------------------------------------------------

HardShoulderStatus innerhard_shoulder_status
bool innerhard_shoulder_status_is_present

HardShoulderStatus outerhard_shoulder_status
bool outerhard_shoulder_status_is_present

DrivingLaneStatus driving_lane_status
bool driving_lane_status_is_present


================================================================================
MSG: etsi_its_cam_ts_msgs/HardShoulderStatus
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the current status of a hard shoulder: whether it is available for special usage
#  * (e.g. for stopping or for driving) or closed for all vehicles.
#  * 
#  * The value shall be set to:
#  * - 0 - `availableForStopping` - if the hard shoulder is available for stopping in e.g. emergency situations,
#  * - 1 - `closed`               - if the hard shoulder is closed and cannot be occupied in any case,
#  * - 2 - `availableForDriving`  - if the hard shoulder is available for regular driving.
#  *
#  * @category: Traffic information
#  * @revision: Description revised in V2.1.1
#  */
# HardShoulderStatus ::= ENUMERATED {
#     availableForStopping (0), 
#     closed               (1), 
#     availableForDriving  (2)
# }
# ------------------------------------------------------------------------------

uint8 value
uint8 AVAILABLE_FOR_STOPPING = 0
uint8 CLOSED = 1
uint8 AVAILABLE_FOR_DRIVING = 2


================================================================================
MSG: etsi_its_cam_ts_msgs/DrivingLaneStatus
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates whether a driving lane is open to traffic.
#  * 
#  * A lane is counted from inside border of the road excluding the hard shoulder. The size of the bit string shall
#  * correspond to the total number of the driving lanes in the carriageway.
#  * 
#  * The numbering is matched to @ref LanePosition.
#  * The bit `0` is used to indicate the innermost lane, bit `1` is used to indicate the second lane from inside border.
#  * 
#  * If a lane is closed to traffic, the corresponding bit shall be set to `1`. Otherwise, it shall be set to `0`.
#  * 
#  * @note: hard shoulder status is not provided by this DE but in @ref HardShoulderStatus.
#  * 
#  * @category: Traffic information
#  * @revision: V1.3.1
#  */
# DrivingLaneStatus ::= BIT STRING (SIZE (1..13))
# ------------------------------------------------------------------------------

uint8[] value
uint8 bits_unused
uint8 MIN_SIZE_BITS = 1
uint8 MAX_SIZE_BITS = 13

"""
  __slots__ = ['roadworks_sub_cause_code','roadworks_sub_cause_code_is_present','light_bar_siren_in_use','closed_lanes','closed_lanes_is_present']
  _slot_types = ['etsi_its_cam_ts_msgs/RoadworksSubCauseCode','bool','etsi_its_cam_ts_msgs/LightBarSirenInUse','etsi_its_cam_ts_msgs/ClosedLanes','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       roadworks_sub_cause_code,roadworks_sub_cause_code_is_present,light_bar_siren_in_use,closed_lanes,closed_lanes_is_present

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(RoadWorksContainerBasic, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.roadworks_sub_cause_code is None:
        self.roadworks_sub_cause_code = etsi_its_cam_ts_msgs.msg.RoadworksSubCauseCode()
      if self.roadworks_sub_cause_code_is_present is None:
        self.roadworks_sub_cause_code_is_present = False
      if self.light_bar_siren_in_use is None:
        self.light_bar_siren_in_use = etsi_its_cam_ts_msgs.msg.LightBarSirenInUse()
      if self.closed_lanes is None:
        self.closed_lanes = etsi_its_cam_ts_msgs.msg.ClosedLanes()
      if self.closed_lanes_is_present is None:
        self.closed_lanes_is_present = False
    else:
      self.roadworks_sub_cause_code = etsi_its_cam_ts_msgs.msg.RoadworksSubCauseCode()
      self.roadworks_sub_cause_code_is_present = False
      self.light_bar_siren_in_use = etsi_its_cam_ts_msgs.msg.LightBarSirenInUse()
      self.closed_lanes = etsi_its_cam_ts_msgs.msg.ClosedLanes()
      self.closed_lanes_is_present = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2B().pack(_x.roadworks_sub_cause_code.value, _x.roadworks_sub_cause_code_is_present))
      _x = self.light_bar_siren_in_use.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_5B().pack(_x.light_bar_siren_in_use.bits_unused, _x.closed_lanes.innerhard_shoulder_status.value, _x.closed_lanes.innerhard_shoulder_status_is_present, _x.closed_lanes.outerhard_shoulder_status.value, _x.closed_lanes.outerhard_shoulder_status_is_present))
      _x = self.closed_lanes.driving_lane_status.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3B().pack(_x.closed_lanes.driving_lane_status.bits_unused, _x.closed_lanes.driving_lane_status_is_present, _x.closed_lanes_is_present))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.roadworks_sub_cause_code is None:
        self.roadworks_sub_cause_code = etsi_its_cam_ts_msgs.msg.RoadworksSubCauseCode()
      if self.light_bar_siren_in_use is None:
        self.light_bar_siren_in_use = etsi_its_cam_ts_msgs.msg.LightBarSirenInUse()
      if self.closed_lanes is None:
        self.closed_lanes = etsi_its_cam_ts_msgs.msg.ClosedLanes()
      end = 0
      _x = self
      start = end
      end += 2
      (_x.roadworks_sub_cause_code.value, _x.roadworks_sub_cause_code_is_present,) = _get_struct_2B().unpack(str[start:end])
      self.roadworks_sub_cause_code_is_present = bool(self.roadworks_sub_cause_code_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.light_bar_siren_in_use.value = str[start:end]
      _x = self
      start = end
      end += 5
      (_x.light_bar_siren_in_use.bits_unused, _x.closed_lanes.innerhard_shoulder_status.value, _x.closed_lanes.innerhard_shoulder_status_is_present, _x.closed_lanes.outerhard_shoulder_status.value, _x.closed_lanes.outerhard_shoulder_status_is_present,) = _get_struct_5B().unpack(str[start:end])
      self.closed_lanes.innerhard_shoulder_status_is_present = bool(self.closed_lanes.innerhard_shoulder_status_is_present)
      self.closed_lanes.outerhard_shoulder_status_is_present = bool(self.closed_lanes.outerhard_shoulder_status_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.closed_lanes.driving_lane_status.value = str[start:end]
      _x = self
      start = end
      end += 3
      (_x.closed_lanes.driving_lane_status.bits_unused, _x.closed_lanes.driving_lane_status_is_present, _x.closed_lanes_is_present,) = _get_struct_3B().unpack(str[start:end])
      self.closed_lanes.driving_lane_status_is_present = bool(self.closed_lanes.driving_lane_status_is_present)
      self.closed_lanes_is_present = bool(self.closed_lanes_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2B().pack(_x.roadworks_sub_cause_code.value, _x.roadworks_sub_cause_code_is_present))
      _x = self.light_bar_siren_in_use.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_5B().pack(_x.light_bar_siren_in_use.bits_unused, _x.closed_lanes.innerhard_shoulder_status.value, _x.closed_lanes.innerhard_shoulder_status_is_present, _x.closed_lanes.outerhard_shoulder_status.value, _x.closed_lanes.outerhard_shoulder_status_is_present))
      _x = self.closed_lanes.driving_lane_status.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3B().pack(_x.closed_lanes.driving_lane_status.bits_unused, _x.closed_lanes.driving_lane_status_is_present, _x.closed_lanes_is_present))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.roadworks_sub_cause_code is None:
        self.roadworks_sub_cause_code = etsi_its_cam_ts_msgs.msg.RoadworksSubCauseCode()
      if self.light_bar_siren_in_use is None:
        self.light_bar_siren_in_use = etsi_its_cam_ts_msgs.msg.LightBarSirenInUse()
      if self.closed_lanes is None:
        self.closed_lanes = etsi_its_cam_ts_msgs.msg.ClosedLanes()
      end = 0
      _x = self
      start = end
      end += 2
      (_x.roadworks_sub_cause_code.value, _x.roadworks_sub_cause_code_is_present,) = _get_struct_2B().unpack(str[start:end])
      self.roadworks_sub_cause_code_is_present = bool(self.roadworks_sub_cause_code_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.light_bar_siren_in_use.value = str[start:end]
      _x = self
      start = end
      end += 5
      (_x.light_bar_siren_in_use.bits_unused, _x.closed_lanes.innerhard_shoulder_status.value, _x.closed_lanes.innerhard_shoulder_status_is_present, _x.closed_lanes.outerhard_shoulder_status.value, _x.closed_lanes.outerhard_shoulder_status_is_present,) = _get_struct_5B().unpack(str[start:end])
      self.closed_lanes.innerhard_shoulder_status_is_present = bool(self.closed_lanes.innerhard_shoulder_status_is_present)
      self.closed_lanes.outerhard_shoulder_status_is_present = bool(self.closed_lanes.outerhard_shoulder_status_is_present)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.closed_lanes.driving_lane_status.value = str[start:end]
      _x = self
      start = end
      end += 3
      (_x.closed_lanes.driving_lane_status.bits_unused, _x.closed_lanes.driving_lane_status_is_present, _x.closed_lanes_is_present,) = _get_struct_3B().unpack(str[start:end])
      self.closed_lanes.driving_lane_status_is_present = bool(self.closed_lanes.driving_lane_status_is_present)
      self.closed_lanes_is_present = bool(self.closed_lanes_is_present)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2B = None
def _get_struct_2B():
    global _struct_2B
    if _struct_2B is None:
        _struct_2B = struct.Struct("<2B")
    return _struct_2B
_struct_3B = None
def _get_struct_3B():
    global _struct_3B
    if _struct_3B is None:
        _struct_3B = struct.Struct("<3B")
    return _struct_3B
_struct_5B = None
def _get_struct_5B():
    global _struct_5B
    if _struct_5B is None:
        _struct_5B = struct.Struct("<5B")
    return _struct_5B
