# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from etsi_its_cam_ts_msgs/SpecialTransportContainer.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import etsi_its_cam_ts_msgs.msg

class SpecialTransportContainer(genpy.Message):
  _md5sum = "9598396c3c953b032df4d050d14a8280"
  _type = "etsi_its_cam_ts_msgs/SpecialTransportContainer"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
# * This type contains detaild information of the Special Transport Container.
# *
# * It shall include the following components:
# *
# * @field specialTransportType: which indicates whether the originating ITS-S is mounted on a special transport vehicle with heavy or oversized load
# * or both. It shall be present if the data is available in originating ITS-S.
# *
# * @field lightBarSirenInUse: indicates whether light-bar or a siren is in use by the vehicle originating the CAM.
# */
# SpecialTransportContainer ::= SEQUENCE {
# 	specialTransportType SpecialTransportType,
# 	lightBarSirenInUse LightBarSirenInUse
# }
# ------------------------------------------------------------------------------

SpecialTransportType special_transport_type

LightBarSirenInUse light_bar_siren_in_use


================================================================================
MSG: etsi_its_cam_ts_msgs/SpecialTransportType
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * The DE indicates if a vehicle is carrying goods in the special transport conditions.
#  *
#  * The corresponding bit shall be set to 1 under the following conditions:
#  * - 0 `heavyLoad`        - the vehicle is carrying goods with heavy load,
#  * - 1 `excessWidth`      - the vehicle is carrying goods in excess of width,
#  * - 2 `excessLength`     - the vehicle is carrying goods in excess of length,
#  * - 3 `excessHeight`     - the vehicle is carrying goods in excess of height.
#  *
#  * Otherwise, the corresponding bit shall be set to 0.
#  * @category Vehicle information
#  * @revision: Description revised in V2.1.1
#  */
# SpecialTransportType ::= BIT STRING {
#     heavyLoad    (0),
#     excessWidth  (1), 
#     excessLength (2), 
#     excessHeight (3)
# } (SIZE(4))
# ------------------------------------------------------------------------------

uint8[] value
uint8 bits_unused
uint8 SIZE_BITS = 4
uint8 BIT_INDEX_HEAVY_LOAD = 0
uint8 BIT_INDEX_EXCESS_WIDTH = 1
uint8 BIT_INDEX_EXCESS_LENGTH = 2
uint8 BIT_INDEX_EXCESS_HEIGHT = 3


================================================================================
MSG: etsi_its_cam_ts_msgs/LightBarSirenInUse
# ==============================================================================
# MIT License
#
# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
# ==============================================================================

# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
# python3
#   utils/codegen/codegen-py/asn1ToRosMsg.py
#   asn1/raw/cam_ts103900/CAM-PDU-Descriptions.asn
#   asn1/patched/cam_ts103900/cdd/ETSI-ITS-CDD.asn
#   -t
#   cam_ts
#   -o
#   etsi_its_msgs/etsi_its_cam_ts_msgs/msg
# ------------------------------------------------------------------------------

# --- ASN.1 Definition ---------------------------------------------------------
# /**
#  * This DE indicates the status of light bar and any sort of audible alarm system besides the horn.
#  * This includes various common sirens as well as backup up beepers and other slow speed manoeuvring alerts.
#  *
#  * The corresponding bit shall be set to 1 under the following conditions:
#  * - 0 - `lightBarActivated`      - when the light bar is activated,
#  * - 1 - `sirenActivated`         - when the siren is activated.
#  *
#  * Otherwise, it shall be set to 0.
#  *
#  * @category Vehicle information
#  * @revision: Editorial update in V2.1.1
#  */
# LightBarSirenInUse ::= BIT STRING {
#     lightBarActivated (0),
#     sirenActivated    (1)
# } (SIZE(2))
# ------------------------------------------------------------------------------

uint8[] value
uint8 bits_unused
uint8 SIZE_BITS = 2
uint8 BIT_INDEX_LIGHT_BAR_ACTIVATED = 0
uint8 BIT_INDEX_SIREN_ACTIVATED = 1

"""
  __slots__ = ['special_transport_type','light_bar_siren_in_use']
  _slot_types = ['etsi_its_cam_ts_msgs/SpecialTransportType','etsi_its_cam_ts_msgs/LightBarSirenInUse']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       special_transport_type,light_bar_siren_in_use

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SpecialTransportContainer, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.special_transport_type is None:
        self.special_transport_type = etsi_its_cam_ts_msgs.msg.SpecialTransportType()
      if self.light_bar_siren_in_use is None:
        self.light_bar_siren_in_use = etsi_its_cam_ts_msgs.msg.LightBarSirenInUse()
    else:
      self.special_transport_type = etsi_its_cam_ts_msgs.msg.SpecialTransportType()
      self.light_bar_siren_in_use = etsi_its_cam_ts_msgs.msg.LightBarSirenInUse()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.special_transport_type.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.special_transport_type.bits_unused
      buff.write(_get_struct_B().pack(_x))
      _x = self.light_bar_siren_in_use.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.light_bar_siren_in_use.bits_unused
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.special_transport_type is None:
        self.special_transport_type = etsi_its_cam_ts_msgs.msg.SpecialTransportType()
      if self.light_bar_siren_in_use is None:
        self.light_bar_siren_in_use = etsi_its_cam_ts_msgs.msg.LightBarSirenInUse()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.special_transport_type.value = str[start:end]
      start = end
      end += 1
      (self.special_transport_type.bits_unused,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.light_bar_siren_in_use.value = str[start:end]
      start = end
      end += 1
      (self.light_bar_siren_in_use.bits_unused,) = _get_struct_B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.special_transport_type.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.special_transport_type.bits_unused
      buff.write(_get_struct_B().pack(_x))
      _x = self.light_bar_siren_in_use.value
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.light_bar_siren_in_use.bits_unused
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.special_transport_type is None:
        self.special_transport_type = etsi_its_cam_ts_msgs.msg.SpecialTransportType()
      if self.light_bar_siren_in_use is None:
        self.light_bar_siren_in_use = etsi_its_cam_ts_msgs.msg.LightBarSirenInUse()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.special_transport_type.value = str[start:end]
      start = end
      end += 1
      (self.special_transport_type.bits_unused,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.light_bar_siren_in_use.value = str[start:end]
      start = end
      end += 1
      (self.light_bar_siren_in_use.bits_unused,) = _get_struct_B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
