
"use strict";

let HumanPresenceOnTheRoadSubCauseCode = require('./HumanPresenceOnTheRoadSubCauseCode.js');
let ExteriorLights = require('./ExteriorLights.js');
let Curvature = require('./Curvature.js');
let RoadWorksContainerBasic = require('./RoadWorksContainerBasic.js');
let EmergencyVehicleApproachingSubCauseCode = require('./EmergencyVehicleApproachingSubCauseCode.js');
let YawRate = require('./YawRate.js');
let PerformanceClass = require('./PerformanceClass.js');
let DeltaLongitude = require('./DeltaLongitude.js');
let SpecialVehicleContainer = require('./SpecialVehicleContainer.js');
let ClosedLanes = require('./ClosedLanes.js');
let SpeedValue = require('./SpeedValue.js');
let TrafficParticipantType = require('./TrafficParticipantType.js');
let HighFrequencyContainer = require('./HighFrequencyContainer.js');
let EmbarkationStatus = require('./EmbarkationStatus.js');
let SteeringWheelAngleValue = require('./SteeringWheelAngleValue.js');
let PathDeltaTime = require('./PathDeltaTime.js');
let RoadworksSubCauseCode = require('./RoadworksSubCauseCode.js');
let ItsPduHeader = require('./ItsPduHeader.js');
let EmergencyPriority = require('./EmergencyPriority.js');
let RescueContainer = require('./RescueContainer.js');
let ProtectedZoneId = require('./ProtectedZoneId.js');
let Altitude = require('./Altitude.js');
let RescueAndRecoveryWorkInProgressSubCauseCode = require('./RescueAndRecoveryWorkInProgressSubCauseCode.js');
let Heading = require('./Heading.js');
let SafetyCarContainer = require('./SafetyCarContainer.js');
let SemiAxisLength = require('./SemiAxisLength.js');
let BasicContainer = require('./BasicContainer.js');
let PositionConfidenceEllipse = require('./PositionConfidenceEllipse.js');
let AccidentSubCauseCode = require('./AccidentSubCauseCode.js');
let SlowVehicleSubCauseCode = require('./SlowVehicleSubCauseCode.js');
let CamPayload = require('./CamPayload.js');
let HazardousLocationObstacleOnTheRoadSubCauseCode = require('./HazardousLocationObstacleOnTheRoadSubCauseCode.js');
let PathPoint = require('./PathPoint.js');
let AccelerationControl = require('./AccelerationControl.js');
let DeltaAltitude = require('./DeltaAltitude.js');
let TrafficConditionSubCauseCode = require('./TrafficConditionSubCauseCode.js');
let CauseCodeChoice = require('./CauseCodeChoice.js');
let HumanProblemSubCauseCode = require('./HumanProblemSubCauseCode.js');
let AdverseWeatherConditionPrecipitationSubCauseCode = require('./AdverseWeatherConditionPrecipitationSubCauseCode.js');
let DangerousSituationSubCauseCode = require('./DangerousSituationSubCauseCode.js');
let StationId = require('./StationId.js');
let CurvatureConfidence = require('./CurvatureConfidence.js');
let CamParameters = require('./CamParameters.js');
let VehicleBreakdownSubCauseCode = require('./VehicleBreakdownSubCauseCode.js');
let LowFrequencyContainer = require('./LowFrequencyContainer.js');
let AltitudeConfidence = require('./AltitudeConfidence.js');
let ReferencePositionWithConfidence = require('./ReferencePositionWithConfidence.js');
let VehicleLengthValue = require('./VehicleLengthValue.js');
let PtActivation = require('./PtActivation.js');
let CurvatureCalculationMode = require('./CurvatureCalculationMode.js');
let ImpassabilitySubCauseCode = require('./ImpassabilitySubCauseCode.js');
let AccelerationComponent = require('./AccelerationComponent.js');
let PtActivationData = require('./PtActivationData.js');
let TimestampIts = require('./TimestampIts.js');
let HazardousLocationDangerousCurveSubCauseCode = require('./HazardousLocationDangerousCurveSubCauseCode.js');
let EmergencyContainer = require('./EmergencyContainer.js');
let AdverseWeatherConditionExtremeWeatherConditionSubCauseCode = require('./AdverseWeatherConditionExtremeWeatherConditionSubCauseCode.js');
let Path = require('./Path.js');
let AltitudeValue = require('./AltitudeValue.js');
let LanePosition = require('./LanePosition.js');
let HazardousLocationSurfaceConditionSubCauseCode = require('./HazardousLocationSurfaceConditionSubCauseCode.js');
let CollisionRiskSubCauseCode = require('./CollisionRiskSubCauseCode.js');
let PtActivationType = require('./PtActivationType.js');
let DangerousGoodsContainer = require('./DangerousGoodsContainer.js');
let CurvatureValue = require('./CurvatureValue.js');
let HeadingConfidence = require('./HeadingConfidence.js');
let PostCrashSubCauseCode = require('./PostCrashSubCauseCode.js');
let LightBarSirenInUse = require('./LightBarSirenInUse.js');
let CauseCodeV2 = require('./CauseCodeV2.js');
let YawRateValue = require('./YawRateValue.js');
let AccelerationConfidence = require('./AccelerationConfidence.js');
let VehicleLength = require('./VehicleLength.js');
let ProtectedZoneRadius = require('./ProtectedZoneRadius.js');
let HazardousLocationAnimalOnTheRoadSubCauseCode = require('./HazardousLocationAnimalOnTheRoadSubCauseCode.js');
let DangerousGoodsBasic = require('./DangerousGoodsBasic.js');
let StationaryVehicleSubCauseCode = require('./StationaryVehicleSubCauseCode.js');
let VehicleRole = require('./VehicleRole.js');
let MessageId = require('./MessageId.js');
let HeadingValue = require('./HeadingValue.js');
let AccelerationValue = require('./AccelerationValue.js');
let DrivingLaneStatus = require('./DrivingLaneStatus.js');
let SignalViolationSubCauseCode = require('./SignalViolationSubCauseCode.js');
let ProtectedZoneType = require('./ProtectedZoneType.js');
let TrafficRule = require('./TrafficRule.js');
let Wgs84AngleValue = require('./Wgs84AngleValue.js');
let SpeedConfidence = require('./SpeedConfidence.js');
let VehicleLengthConfidenceIndication = require('./VehicleLengthConfidenceIndication.js');
let VehicleWidth = require('./VehicleWidth.js');
let ProtectedCommunicationZonesRSU = require('./ProtectedCommunicationZonesRSU.js');
let GenerationDeltaTime = require('./GenerationDeltaTime.js');
let SubCauseCodeType = require('./SubCauseCodeType.js');
let SpecialTransportContainer = require('./SpecialTransportContainer.js');
let AdverseWeatherConditionAdhesionSubCauseCode = require('./AdverseWeatherConditionAdhesionSubCauseCode.js');
let AdverseWeatherConditionVisibilitySubCauseCode = require('./AdverseWeatherConditionVisibilitySubCauseCode.js');
let PublicTransportContainer = require('./PublicTransportContainer.js');
let WrongWayDrivingSubCauseCode = require('./WrongWayDrivingSubCauseCode.js');
let SteeringWheelAngle = require('./SteeringWheelAngle.js');
let CAM = require('./CAM.js');
let BasicVehicleContainerLowFrequency = require('./BasicVehicleContainerLowFrequency.js');
let CenDsrcTollingZone = require('./CenDsrcTollingZone.js');
let DriveDirection = require('./DriveDirection.js');
let ProtectedCommunicationZone = require('./ProtectedCommunicationZone.js');
let SpecialTransportType = require('./SpecialTransportType.js');
let Latitude = require('./Latitude.js');
let SpeedLimit = require('./SpeedLimit.js');
let DeltaReferencePosition = require('./DeltaReferencePosition.js');
let BasicVehicleContainerHighFrequency = require('./BasicVehicleContainerHighFrequency.js');
let Longitude = require('./Longitude.js');
let OrdinalNumber1B = require('./OrdinalNumber1B.js');
let DeltaLatitude = require('./DeltaLatitude.js');
let RSUContainerHighFrequency = require('./RSUContainerHighFrequency.js');
let HardShoulderStatus = require('./HardShoulderStatus.js');
let Speed = require('./Speed.js');
let DangerousEndOfQueueSubCauseCode = require('./DangerousEndOfQueueSubCauseCode.js');
let SteeringWheelAngleConfidence = require('./SteeringWheelAngleConfidence.js');
let RailwayLevelCrossingSubCauseCode = require('./RailwayLevelCrossingSubCauseCode.js');
let YawRateConfidence = require('./YawRateConfidence.js');

module.exports = {
  HumanPresenceOnTheRoadSubCauseCode: HumanPresenceOnTheRoadSubCauseCode,
  ExteriorLights: ExteriorLights,
  Curvature: Curvature,
  RoadWorksContainerBasic: RoadWorksContainerBasic,
  EmergencyVehicleApproachingSubCauseCode: EmergencyVehicleApproachingSubCauseCode,
  YawRate: YawRate,
  PerformanceClass: PerformanceClass,
  DeltaLongitude: DeltaLongitude,
  SpecialVehicleContainer: SpecialVehicleContainer,
  ClosedLanes: ClosedLanes,
  SpeedValue: SpeedValue,
  TrafficParticipantType: TrafficParticipantType,
  HighFrequencyContainer: HighFrequencyContainer,
  EmbarkationStatus: EmbarkationStatus,
  SteeringWheelAngleValue: SteeringWheelAngleValue,
  PathDeltaTime: PathDeltaTime,
  RoadworksSubCauseCode: RoadworksSubCauseCode,
  ItsPduHeader: ItsPduHeader,
  EmergencyPriority: EmergencyPriority,
  RescueContainer: RescueContainer,
  ProtectedZoneId: ProtectedZoneId,
  Altitude: Altitude,
  RescueAndRecoveryWorkInProgressSubCauseCode: RescueAndRecoveryWorkInProgressSubCauseCode,
  Heading: Heading,
  SafetyCarContainer: SafetyCarContainer,
  SemiAxisLength: SemiAxisLength,
  BasicContainer: BasicContainer,
  PositionConfidenceEllipse: PositionConfidenceEllipse,
  AccidentSubCauseCode: AccidentSubCauseCode,
  SlowVehicleSubCauseCode: SlowVehicleSubCauseCode,
  CamPayload: CamPayload,
  HazardousLocationObstacleOnTheRoadSubCauseCode: HazardousLocationObstacleOnTheRoadSubCauseCode,
  PathPoint: PathPoint,
  AccelerationControl: AccelerationControl,
  DeltaAltitude: DeltaAltitude,
  TrafficConditionSubCauseCode: TrafficConditionSubCauseCode,
  CauseCodeChoice: CauseCodeChoice,
  HumanProblemSubCauseCode: HumanProblemSubCauseCode,
  AdverseWeatherConditionPrecipitationSubCauseCode: AdverseWeatherConditionPrecipitationSubCauseCode,
  DangerousSituationSubCauseCode: DangerousSituationSubCauseCode,
  StationId: StationId,
  CurvatureConfidence: CurvatureConfidence,
  CamParameters: CamParameters,
  VehicleBreakdownSubCauseCode: VehicleBreakdownSubCauseCode,
  LowFrequencyContainer: LowFrequencyContainer,
  AltitudeConfidence: AltitudeConfidence,
  ReferencePositionWithConfidence: ReferencePositionWithConfidence,
  VehicleLengthValue: VehicleLengthValue,
  PtActivation: PtActivation,
  CurvatureCalculationMode: CurvatureCalculationMode,
  ImpassabilitySubCauseCode: ImpassabilitySubCauseCode,
  AccelerationComponent: AccelerationComponent,
  PtActivationData: PtActivationData,
  TimestampIts: TimestampIts,
  HazardousLocationDangerousCurveSubCauseCode: HazardousLocationDangerousCurveSubCauseCode,
  EmergencyContainer: EmergencyContainer,
  AdverseWeatherConditionExtremeWeatherConditionSubCauseCode: AdverseWeatherConditionExtremeWeatherConditionSubCauseCode,
  Path: Path,
  AltitudeValue: AltitudeValue,
  LanePosition: LanePosition,
  HazardousLocationSurfaceConditionSubCauseCode: HazardousLocationSurfaceConditionSubCauseCode,
  CollisionRiskSubCauseCode: CollisionRiskSubCauseCode,
  PtActivationType: PtActivationType,
  DangerousGoodsContainer: DangerousGoodsContainer,
  CurvatureValue: CurvatureValue,
  HeadingConfidence: HeadingConfidence,
  PostCrashSubCauseCode: PostCrashSubCauseCode,
  LightBarSirenInUse: LightBarSirenInUse,
  CauseCodeV2: CauseCodeV2,
  YawRateValue: YawRateValue,
  AccelerationConfidence: AccelerationConfidence,
  VehicleLength: VehicleLength,
  ProtectedZoneRadius: ProtectedZoneRadius,
  HazardousLocationAnimalOnTheRoadSubCauseCode: HazardousLocationAnimalOnTheRoadSubCauseCode,
  DangerousGoodsBasic: DangerousGoodsBasic,
  StationaryVehicleSubCauseCode: StationaryVehicleSubCauseCode,
  VehicleRole: VehicleRole,
  MessageId: MessageId,
  HeadingValue: HeadingValue,
  AccelerationValue: AccelerationValue,
  DrivingLaneStatus: DrivingLaneStatus,
  SignalViolationSubCauseCode: SignalViolationSubCauseCode,
  ProtectedZoneType: ProtectedZoneType,
  TrafficRule: TrafficRule,
  Wgs84AngleValue: Wgs84AngleValue,
  SpeedConfidence: SpeedConfidence,
  VehicleLengthConfidenceIndication: VehicleLengthConfidenceIndication,
  VehicleWidth: VehicleWidth,
  ProtectedCommunicationZonesRSU: ProtectedCommunicationZonesRSU,
  GenerationDeltaTime: GenerationDeltaTime,
  SubCauseCodeType: SubCauseCodeType,
  SpecialTransportContainer: SpecialTransportContainer,
  AdverseWeatherConditionAdhesionSubCauseCode: AdverseWeatherConditionAdhesionSubCauseCode,
  AdverseWeatherConditionVisibilitySubCauseCode: AdverseWeatherConditionVisibilitySubCauseCode,
  PublicTransportContainer: PublicTransportContainer,
  WrongWayDrivingSubCauseCode: WrongWayDrivingSubCauseCode,
  SteeringWheelAngle: SteeringWheelAngle,
  CAM: CAM,
  BasicVehicleContainerLowFrequency: BasicVehicleContainerLowFrequency,
  CenDsrcTollingZone: CenDsrcTollingZone,
  DriveDirection: DriveDirection,
  ProtectedCommunicationZone: ProtectedCommunicationZone,
  SpecialTransportType: SpecialTransportType,
  Latitude: Latitude,
  SpeedLimit: SpeedLimit,
  DeltaReferencePosition: DeltaReferencePosition,
  BasicVehicleContainerHighFrequency: BasicVehicleContainerHighFrequency,
  Longitude: Longitude,
  OrdinalNumber1B: OrdinalNumber1B,
  DeltaLatitude: DeltaLatitude,
  RSUContainerHighFrequency: RSUContainerHighFrequency,
  HardShoulderStatus: HardShoulderStatus,
  Speed: Speed,
  DangerousEndOfQueueSubCauseCode: DangerousEndOfQueueSubCauseCode,
  SteeringWheelAngleConfidence: SteeringWheelAngleConfidence,
  RailwayLevelCrossingSubCauseCode: RailwayLevelCrossingSubCauseCode,
  YawRateConfidence: YawRateConfidence,
};
